#include <htc.h>
#include "hitec_c_i2c.h"
#include "user_define.h"
#include "m6955_am.h"

/*----------- m6955 ----------*/
void	m6955_am_init(void)
{
	i2c_m6955_write(0x00,0x80);
	i2c_m6955_write(0x06,0xfc);
	i2c_m6955_write(0x07,0x31);
	i2c_m6955_write(0x09,0x07);
	i2c_m6955_write(0x01,0x11);
}

void	m6955_am_tune(unsigned int freq)
{
unsigned int	data;
unsigned char	d1,d2;

	data=(freq/9)*3;
	d1=(unsigned char)data & 0xff;
	d2=(unsigned char)((data >> 8) | 0x40);
	i2c_m6955_write(0x03,d1);
	i2c_m6955_write(0x02,d2);

	i2c_m6955_write(0x00,0x80);
	__delay_ms(1);
	i2c_m6955_write(0x00,0xa0);
	__delay_ms(1);
	i2c_m6955_write(0x00,0x80);
}

void	tune_sub(unsigned int am_khz)
{
	m6955_am_tune(am_khz);
}

unsigned int	read_sig(void)
{
unsigned int	data0,data1,data2;
unsigned int	ret;

	data0=(unsigned int)i2c_m6955_read(0x18);
	data1=(data0 & 0xe0) >> 5;
	data2=(data0 & 0x1c) >> 2;
	data0=(unsigned int)i2c_m6955_read(0x1b);
	data0=data0 & 0x7f;

	ret=123-data0-data1*6-data2*6;

	//ret=i2c_m6955_read(0x16) & 0x7f;

	return ret;	
}
