#define _LEGACY_HEADERS

#include <htc.h>
#include <pic16f886.h>
#include "hitec_c_i2c.h"
#include "port_init.h"
#include "wait_time.h"
#include "m6955_am.h" 
#include "user_define.h"
#include "usart.h"

__CONFIG(	DEBUGDIS & LVPDIS & FCMDIS & IESODIS & BORDIS
			& DUNPROTECT & UNPROTECT & MCLREN & PWRTEN & WDTDIS & INTIO);
__CONFIG(	0xffff & BORV21);


unsigned int	khz_no;
unsigned int	rqst_rssi;
unsigned int	data_rssi;
unsigned char	width;

unsigned char	receive_data;
unsigned int	receive_flg;	/* 1:M 0:M */

/*--------------------USART INTERRUPT-------------*/
void	interrupt InterReceiver(void)
{
	if(RCIF==1){
		receive_data=RCREG;
		receive_flg=1;
		RCIF =0;
	}
}
/*---------------------TUNE TX--------------------*/
void	data_tx(unsigned int data)
{
unsigned char	no;

	no=(unsigned char)(data);
	putch(no);
}
/*---------------------MAIN-----------------------*/
void	main(void)
{

	port_init();

	__delay_ms(5000);

	width=2;
	I2CInit();

	receive_flg=0;
	init_usart();	

	m6955_am_init();

	__delay_ms(3000);

	khz_no=1557;
	tune_sub(khz_no);rqst_rssi=1;



	while(1){


		wait_time(1000);
		if(receive_flg==1){
			RB0=0;NOP();
			if(receive_data>50){
				khz_no=(unsigned int)receive_data*9;
				tune_sub(khz_no);rqst_rssi=1;
			}
			if(receive_data<5){
				width=receive_data;
				//si47xx_set_property(AM_CHANNEL_FILTER, width);	
			}
			receive_flg=0;
			RB0=1;NOP();
		}


		/*------------------ */
		if(rqst_rssi>0){
			rqst_rssi--;
			if(rqst_rssi==0){
				rqst_rssi=RQST_RSSI_INIT;
				data_rssi=read_sig();
				if(data_rssi>99){data_rssi=99;}
				data_tx(data_rssi);				
			}
		}



	}

}